<template>
  <q-page class="q-pa-md">
    <q-layout view="lHh Lpr lFf">
      <q-page-container>
        <div class="row q-gutter-md q-mt-md">
          <div class="col-12">
            <q-input
              filled
              v-model="searchQuery"
              label="Recherche d'articles"
              dense
              bg-color="white"
              color="secondary"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>
          </div>
        </div>
        <div class="row q-mt-lg">
          <div class="col-12 col-md-6 col-lg-4 col-xl-3" v-for="post in filteredLinksList" :key="post.id">
            <post-card :post="post" />
          </div>
        </div>
      </q-page-container>
    </q-layout>
  </q-page>
</template>

<script setup lang="ts">
import { ref, computed } from 'vue';
import PostCard, { PostCardProps } from 'components/PostCard.vue';

import image1 from '../assets/images/exploration-du-champ-etoiles-nature-telescope-genere-par-ia.jpg';
import image2 from '../assets/images/pexels-creationsbyfaik-1025469.jpg';
import image3 from '../assets/images/pexels-pixabay-2166.jpg';
import image4 from '../assets/images/pexels-pixabay-87009.jpg';
import image5 from '../assets/images/prise-vue-verticale-beau-ciel-etoile.jpg';
import image6 from '../assets/images/pexels-pixabay-2156.jpg';
import image7 from '../assets/images/pexels-pixabay-39896.jpg';
import image8 from '../assets/images/pexels-pixabay-87611.jpg';
import image9 from '../assets/images/satellite-brillant-orbite-autour-planete-dans-galaxie-remplie-etoiles-generee-par-ia.jpg';

defineOptions({
  name: 'ExplorePage'
});

const images = [
  image1,
  image2,
  image3,
  image4,
  image5,
  image6,
  image7,
  image8,
  image9,
];

const messages = [
  'Exploring the wonders of the universe.',
  'Have you seen the latest astronomical event?',
  'A breathtaking view of the Milky Way.',
  'Spotting the Andromeda Galaxy with binoculars!',
  'Observing the Great Red Spot on Jupiter.',
  'A clear night with perfect visibility.',
  'Capturing the beauty of a lunar eclipse.',
  'The International Space Station passing overhead.',
  'Stargazing on a beautiful clear night.',
  'An incredible night of astrophotography.'
];

const randomImage = () => images[Math.floor(Math.random() * images.length)];

const linksList: PostCardProps['post'][] = Array.from({ length: 25 }, (_, i) => ({
  id: (i + 1).toString(),
  date: '2024-06-' + (i + 1).toString().padStart(2, '0'),
  link: '/post/' + (i + 1),
  likes: Math.floor(Math.random() * 500),
  comments: Math.floor(Math.random() * 100),
  message: `Post ${i + 1}: ${messages[i % messages.length]}`,
  image: randomImage(),
  author: {
    name: `Author ${i + 1}`,
    username: `author_${i + 1}`,
    avatar: `https://cdn.quasar.dev/img/avatar${(i % 5) + 1}.jpg`,
  },
}));

const searchQuery = ref('');
const filteredLinksList = computed(() => {
  if (!searchQuery.value) {
    return linksList;
  }
  return linksList.filter(post =>
    post.message?.toLowerCase().includes(searchQuery.value.toLowerCase())
  );
});
</script>


<style lang="scss">
// reset link styles
a {
  text-decoration: none;
  color: inherit;
}
</style>



